/**
 | Test program for list.hh
**/

#include <algorithm>
#include <numeric>
#include <iostream>
#include "slist.hh"

using std::copy;
using std::cout;
using std::endl;
using std::find;
using std::ostream_iterator;

int main() {
  List<int> x;
  x.push_front(3);
  x.push_front(4);
  x.push_front(9);
  cout << "The list is: ";
  copy(x.begin(), x.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  cout << "Looking for '4': ";
  List<int>::iterator it = find(x.begin(), x.end(), 4);
  if (it != x.end()) {
    cout << "found '" << *it << "'\n";
  } else {
    cout << "not found\n";
    return 1;
  }

  x.insert_after(it, 11);
  x.insert_after(it, 42);
  cout << "Inserting '11' and '42' after '4'; the list is: ";
  copy(x.begin(), x.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  it = x.begin() + 1;
  cout << "The second element is: " << *it << endl;

  it = x.begin();
  it += 1;
  x.erase_after(it);
  cout << "Erasing the third element; the list is: ";
  copy(x.begin(), x.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  int sum = std::accumulate (x.begin(), x.end(), 0);
  int sumsq = std::inner_product(x.begin(), x.end(), x.begin(), 0);
  cout << "The sum is: " << sum;
  cout << "; the sum of the squares is: " << sumsq << endl;

  List<int> y = x;
  cout << "Assigning ... list 1 is: ";
  copy(x.begin(), x.end(), ostream_iterator<int>(cout, " "));
  cout << "; list 2 is: ";
  copy(y.begin(), y.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  List<int>::const_iterator cit;
  cit = y.begin();
  cout << "List 2: 2nd element = " << *(cit+1) << "; 3rd element = ";
  cit += 2;
  cout << *cit << endl;

  return 0;
}
